<template>
  <div>
    <h2 id="page-heading" data-cy="SuenoHeading">
      <span v-text="$t('gatewayApp.manillaSueno.home.title')" id="sueno-heading">Suenos</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.manillaSueno.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'SuenoCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-sueno"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.manillaSueno.home.createLabel')"> Create a new Sueno </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && suenos && suenos.length === 0">
      <span v-text="$t('gatewayApp.manillaSueno.home.notFound')">No suenos found</span>
    </div>
    <div class="table-responsive" v-if="suenos && suenos.length > 0">
      <table class="table table-striped" aria-describedby="suenos">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('superficial')">
              <span v-text="$t('gatewayApp.manillaSueno.superficial')">Superficial</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'superficial'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('profundo')">
              <span v-text="$t('gatewayApp.manillaSueno.profundo')">Profundo</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'profundo'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('despierto')">
              <span v-text="$t('gatewayApp.manillaSueno.despierto')">Despierto</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'despierto'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('timeInstant')">
              <span v-text="$t('gatewayApp.manillaSueno.timeInstant')">Time Instant</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'timeInstant'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.manillaSueno.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="sueno in suenos" :key="sueno.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'SuenoView', params: { suenoId: sueno.id } }">{{ sueno.id }}</router-link>
            </td>
            <td>{{ sueno.superficial }}</td>
            <td>{{ sueno.profundo }}</td>
            <td>{{ sueno.despierto }}</td>
            <td>{{ sueno.timeInstant ? $d(Date.parse(sueno.timeInstant), 'short') : '' }}</td>
            <td>
              {{ sueno.user ? sueno.user.login : '' }}
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'SuenoView', params: { suenoId: sueno.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'SuenoEdit', params: { suenoId: sueno.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(sueno)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.manillaSueno.delete.question" data-cy="suenoDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-sueno-heading" v-text="$t('gatewayApp.manillaSueno.delete.question', { id: removeId })">
          Are you sure you want to delete this Sueno?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-sueno"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeSueno()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./sueno.component.ts"></script>
